int WINDOW_SIZE_X = 640;
int WINDOW_SIZE_Y = 480;

int x1, x2, y1, y2;
color pen_color, keshigomu_color;
int pen_size;
int keshigomu_mode;
int[] stack_x, stack_y;
int stack_top;

void setup() {
  size(WINDOW_SIZE_X, WINDOW_SIZE_Y); 
  background(255, 255, 255);
  noFill();
  pen_color = color(0, 0, 0);
  keshigomu_color = color(255, 255, 255);
  stroke(pen_color); 
  pen_size = 5;
  strokeWeight(pen_size);
  keshigomu_mode = 0;
  stack_x = new int[WINDOW_SIZE_X * WINDOW_SIZE_Y];
  stack_y = new int[WINDOW_SIZE_X * WINDOW_SIZE_Y];
  stack_top = 0;
}

void mouseDragged() {
  x2 = mouseX;
  y2 = mouseY;
  line(x1, y1, x2, y2);
  x1 = x2;
  y1 = y2;
}

void mousePressed() {
  x1 = mouseX;
  y1 = mouseY;
}

void keyPressed() {
  if(key == ' ') {
    if(keshigomu_mode == 1) {
      keshigomu_mode = 0;
      stroke(pen_color);
      pen_size = 5;
    } else {
      keshigomu_mode = 1;
      stroke(keshigomu_color);
      pen_size = 10;
    } 
  }
  if(key == 's') {
    save("oekaki.png");
  }
}

void push(int x, int y) {
  stack_x[stack_top] = x;
  stack_y[stack_top] = y;
  stack_top++;
}

void Nuritsubushi(int mouse_x, int mouse_y) {
  int x, y;
  color c;
  push(mouse_x, mouse_y);
  strokeWeight(1);
  
  while(stack_top != 0 ) { 
    stack_top--;    
    x = stack_x[stack_top];
    y = stack_y[stack_top];   
    
    point(x, y);
    
    c = get(x+1, y);
    if(c != pen_color){ push(x+1, y); }
    
    c = get(x-1, y);
    if(c != pen_color){ push(x-1, y); }
    
    c = get(x, y+1);
    if(c != pen_color){ push(x, y+1); }
    
    c = get(x, y-1);
    if(c != pen_color){ push(x, y-1); }    
  }
  strokeWeight(pen_size);
}

void draw(){
  strokeWeight(1);
  rect(0, 0, WINDOW_SIZE_X-1, WINDOW_SIZE_Y-1); 
  strokeWeight(pen_size);
   
  if (mousePressed && (mouseButton == RIGHT) && keshigomu_mode == 0) {
    Nuritsubushi(mouseX, mouseY);
  }
}

